import numpy

import Orange.data
from Orange.widgets.widget import OWWidget, Input, Output
from Orange.widgets.utils.widgetpreview import WidgetPreview
from Orange.widgets import gui, settings

class Absolute(OWWidget):
    name = "Absolute"
    description = "Absolute value of given inputs."
    icon = "icons/absolute.svg"
    priority = 20

    class Inputs:
        a = Input("A", numpy.ndarray)

    class Outputs:
        absOut = Output("|A|", numpy.ndarray)

    want_main_area = False


    def __init__(self):
        super().__init__()
        self.a = None
        box = gui.widgetBox(self.controlArea, "Info")
        self.infoA = gui.widgetLabel(box, "No data on input yet, waiting to get something.")

    @Inputs.a
    def set_data_a(self, a):
        if a is not None:
            self.infoA.setText("Input A is " + str(a.dtype))
            self.a = a
        else:
            self.infoA.setText("No data on input yet, waiting to get something.")

    def handleNewSignals(self):
        if ((self.Inputs.a is not None)):
            self.Outputs.absOut.send(numpy.abs(self.a))
        else:
            self.Outputs.absOut.send(None)

