import numpy

import Orange.data
from Orange.widgets.widget import OWWidget, Input, Output
from Orange.widgets.utils.widgetpreview import WidgetPreview
from Orange.widgets import gui, settings

class Adder(OWWidget):
    name = "Adder"
    description = "Adds values of given inputs."
    icon = "icons/addition.svg"
    priority = 20

    class Inputs:
        a = Input("A", numpy.ndarray)
        b = Input("B", numpy.ndarray)

    class Outputs:
        add = Output("A + B", numpy.ndarray)

    want_main_area = False

    def __init__(self):
        super().__init__()
        self.a = None
        self.b = None
        

        # GUI

        box = gui.widgetBox(self.controlArea, "Info")
        self.infoa = gui.widgetLabel(box, "No data on input yet, waiting to get something.")
        self.infob = gui.widgetLabel(box, "No data on input yet, waiting to get something.")

    @Inputs.a
    def set_data_a(self, a):
        if a is not None:
            self.infoa.setText("Input A is " + str(a.dtype))
            self.a = a
        else:
            self.infoa.setText("No data on input yet, waiting to get something.")

    @Inputs.b
    def set_data_b(self, b):
        if b is not None:
            self.infob.setText("Input B is " + str(b.dtype))
            self.b = b
        else:
            self.infob.setText("No data on input yet, waiting to get something.")



    # def subtractor_type(self,block1, block2, type):
    #     b1 = Casting.caster(block1, type)
    #     b2 = Casting.caster(block2, type)
    #     res = numpy.subtract(b1, b2)
    #     return res, type
        
    def handleNewSignals(self):
        if ((self.Inputs.a is not None) and (self.Inputs.b is not None)):
            self.Outputs.add.send(numpy.add(self.a, self.b) )
        else:
            self.Outputs.add.send(None)
