import numpy
import cv2 as cv
import Orange.data
from orangewidget.widget import OWBaseWidget, Input, Output
from orangewidget.utils.widgetpreview import WidgetPreview
from orangewidget import gui, settings
from AnyQt import QtCore
from orangewidget.settings import Setting
from AnyQt import QtWidgets, QtGui
class Casting(OWBaseWidget):
    name = "Casting"
    description = "Modify the data type of the input data"
    icon = "icons/casting.svg"
    priority = 10
    # Basic (convenience) GUI definition:
    #   a simple 'single column' GUI layout
    want_main_area = True
    #   with a fixed non resizable geometry.
    


    class Inputs:
        frameIn = Input("FrameIn", numpy.ndarray)

    class Outputs:
        frameOut = Output("FrameOut", numpy.ndarray)

    OutType = settings.Setting(0)
    MODES = ['2uint8','2double']
    def __init__(self):
        super().__init__()
        from AnyQt.QtGui import QIntValidator
        box = gui.widgetBox(self.controlArea, "Info")
        self.infoa = gui.widgetLabel(box, "No data on input yet, waiting to get something.")

        gui.separator(self.controlArea)
        self.qtSelect = gui.comboBox(self, self, 'OutType', items=self.MODES, callback=self.handleNewSignals)
        self.qtSelect.setToolTip("Select the output data type")
    def caster(self,framein):
        print("Selected Mode: ", self.OutType)
        if(self.MODES[self.OutType] == "2uint8"):
            return numpy.clip(numpy.round(framein), 0 ,255).astype('uint8')
        else:
            return framein.astype('double')
        
        '''if(framein.ndim == 1):
            if(self.OutType == "2uint8"):
                ArrayAux = numpy.zeros((framein.shape[0],framein.shape[1],3),dtype=numpy.int8)
                ArrayAux[:,:,0] = framein[:,:]
                ArrayAux[:,:,1] = framein[:,:]
                ArrayAux[:,:,2] = framein[:,:]
                return ArrayAux.astype('uint8')
            else:
                return framein.astype('double')'''
                
    @Inputs.frameIn
    def set_frame(self, inputframe):
        if inputframe is not None:
            self.frameIn = inputframe
            self.infoa.setText("Input is " + str(inputframe.dtype))
        else:
            self.infoa.setText("No data on input yet, waiting to get something.")
            self.frameIn = None

    def handleNewSignals(self):
        if self.frameIn is not None:
            self.mode = self.MODES[self.OutType]
            output = self.caster(self.frameIn)
            print("output is:", type(output))
            self.Outputs.frameOut.send(output)
        else:
            self.Outputs.frameOut.send(None)
            
