import numpy
import scipy.fftpack as sfft
import Orange.data
import cv2
from Orange.widgets.widget import OWWidget, Input, Output
from Orange.widgets.utils.widgetpreview import WidgetPreview
from Orange.widgets import gui, settings

class DCT(OWWidget):
    name = "DCT"
    description = "Calculate the Discrete Cosine Transform (II) of an image."
    icon = "icons/DCT.svg"
    priority = 20

    class Inputs:
        a = Input("A", numpy.ndarray)

    class Outputs:
        dctA = Output("var(A)", numpy.ndarray)

    want_main_area = False
    proportion = settings.Setting(50)
    mode = settings.Setting(0)
    # [end-snippet-1]

    def __init__(self):
        super().__init__()

        self.dataset = None
        self.sample = None

        # GUI
        # [start-snippet-3]
        box = gui.widgetBox(self.controlArea, "Info")
        self.infoa = gui.widgetLabel(box, "No data on input yet, waiting to get something.")


    @Inputs.a
    def set_data_a(self, a):
        if a is not None:
            self.infoa.setText("input A is correct")
            self.a = a
        else:
            self.infoa.setText("No data on input yet, waiting to get something.")

    def idct2(a):
        return sfft.idct( sfft.idct( a, axis=0 , norm='ortho'), axis=1 , norm='ortho')
        
        
    def DCTOpencv(self,img,M,N,inverse):
        #img = cv2.cvtColor(img2, cv2.COLOR_BGR2GRAY)
        if(img.ndim > 2): #solo se selecciona el primer canal
            imgOrig = img.copy()
            img=img[:,:,0]
        inp = (img.astype('float')/255)
        flags = cv2.DCT_INVERSE if inverse else 0
        (m,n) = img.shape[:2]
        out = numpy.zeros((m,n))
        for i in range(0,m,M):
            for j in range(0,n,N):
                out[i:i+M,j:j+N] = cv2.dct(inp[i:i+M,j:j+N],flags =flags)
        out = out*255
        # if (imgOrig.ndim > 2):
        #     imgOrig[:, :, 0] = out
        #     imgOrig[:, :, 1] = out
        #     imgOrig[:, :, 2] = out
        #     out = imgOrig
        return out

    # def dct(self, image):
    #     dim = image.shape
    #     image = image.astype("float64")
    #     filas = dim[0]
    #     columnas = dim[1]
    #     block = numpy.zeros((8, 8))
    #     blockres = numpy.zeros((8, 8))
    #     imares = image
    #     for ypos in range(0, filas, 8):
    #         f_ini = ypos
    #         f_fin = min(ypos + 8, filas)
    #         for xpos in range(0, columnas, 8):
    #             c_ini = xpos
    #             c_fin = min(xpos + 8, columnas)
    #             # Ya tenemos los bloques
    #             block = image[f_ini:f_fin, c_ini:c_fin]
    #             blockres = sfft.dctn(block,axes=[0,1])
    #
    #             imares[f_ini:f_fin, c_ini:c_fin] = blockres
    #
    #     return imares


    def handleNewSignals(self):
        if (self.a is not None) :
            newdct = self.DCTOpencv(self.a,8,8,False)
            self.Outputs.dctA.send(newdct)

    # def commit(self):
    #     dct_value = self.dct(self.a)
    #     self.Outputs.varA.send(dct_value)

    # def checkCommit(self):
    #     if self.commitOnChange:
    #         self.commit()

    def caster(inimag, type):
        res = inimag.astype(type)
        return res


