from Orange.widgets.widget import OWWidget
from Orange.widgets import gui, settings
from AnyQt import QtCore

print("Se lee esto o qué?")

from orangewidget.widget import OWBaseWidget, Input, Output
import matplotlib
from matplotlib.widgets import Cursor
#import matplotlib.widgets

import numpy
import pyqtgraph.widgets.MatplotlibWidget
import matplotlib.image
from orangewidget.utils.widgetpreview import WidgetPreview



class ImShow(OWWidget):
    # Widget needs a name, or it is considered an abstract widget
    # and not shown in the menu.
    name = "Display Image"
    icon = "icons/Display1.svg"
    description = "Displays an image"

    want_main_area = False
    want_message_bar = False

    message = settings.Setting("")

    class Inputs:
        Image = Input("Image", numpy.ndarray)
        
        
    def do_nothing(self, image):
        if image is None:
            self.axes.clear()
        #lena = matplotlib.image.imread("/Users/dbd/Downloads/Lenna.png")
        #lena = numpy.uint8(255 * lena)
        else:
            #self.axes.quiver([0, 0, 0], [0, 0, 0], [1, 5, 7], [1, 5, 7], angles='xy', scale_units='xy', scale=1)
            self.imageaxes = self.axes.imshow(image[...,::-1], origin='upper')
            #if self.Vectors is not None:
            #    self.VectorsQuiver =  self.axes.quiver(self.Vectors[:,1],self.Vectors[:,0],self.Vectors[:,3],self.Vectors[:,2], angles='xy', scale_units='xy', scale=1, color="b",mouseover = True)
            #self.cursor = Cursor(self.axes, useblit=True, color='red', linewidth=2)
            #self.quiver([0, 0, 0], [0, 0, 0], [1, -2, 4], [1, 2, -7], angles='xy', scale_units='xy', scale=1)


        
    # @Inputs.Vectors
    # def set_Vectors(self, Vectors):
    #     if Vectors is not None:
    #         self.axes.clear()
    #         self.Vectors = Vectors
    #         self.do_nothing(self.Image)
    #     else:
    #         self.Vectors = None
    #         self.VectorsQuiver.remove()
    #     self.mw.draw()
    @Inputs.Image
    def set_Image(self, Image):
        if Image is not None:
            self.axes.clear()
            Image = Image.astype('uint8')
            if(Image.ndim == 2):
                Image = numpy.repeat(Image[...,None],3,axis=2)
            self.Image = Image
            self.do_nothing(Image)
        else:
            self.axes.clear()
            print("Trying to clear the image")
        self.mw.draw()

    def __init__(self):
        super().__init__()
        self.Vectors = None
        self.Image = None
        self.mw = pyqtgraph.widgets.MatplotlibWidget.MatplotlibWidget()
        self.mw.toolbar.set_message("Click on the image to explore values.")
        self.controlArea.layout().addWidget(
            self.mw, QtCore.Qt.AlignCenter | QtCore.Qt.AlignVCenter)
        self.fig = self.mw.getFigure()
        self.fig.set_facecolor('#00000000')
        self.axes = self.fig.add_subplot(1, 1, 1)
        # self.VectorsQuiver = self.axes.quiver(0,0)
        self.fig.set_tight_layout(True)
        self.fig.canvas.mpl_connect('motion_notify_event', self.mouse_move)
        self.message = "Click on image to explore values"
        message_label = gui.label(self.controlArea, master=self, label="<pre>%(message)s</pre>")
        message_label.setTextFormat(QtCore.Qt.RichText)





    def mouse_move(self, event):
        try:
            self.message = self.axes.format_coord(int(0.5 + event.xdata),
                                                  int(0.5 + event.ydata)) + self.axes.format_cursor_data(self.imageaxes.get_cursor_data(event))
        except:
            pass
        #if event.inaxes is not None:



if __name__ == "__main__":
    array = numpy.linspace(0, 1, 256 * 256)

    # reshape to 2d
    mat = numpy.reshape(array, (256, 256))

    # Creates PIL image
    img = numpy.uint8(mat * 255)
    WidgetPreview(ImShow).run()

