import numpy

import Orange.data
from Orange.widgets.widget import OWWidget, Input, Output
from Orange.widgets.utils.widgetpreview import WidgetPreview
from Orange.widgets import gui, settings


class Substractor(OWWidget):
    name = "Substractor"
    description = "Substract two arrays."
    icon = "icons/Substractor.svg"
    priority = 20

    class Inputs:
        a = Input("A", numpy.ndarray)
        b = Input("B", numpy.ndarray)

    class Outputs:
        subs = Output("A - B", numpy.ndarray)

    want_main_area = False

    def __init__(self):
        super().__init__()
        self.a = None
        self.b = None

        # GUI

        box = gui.widgetBox(self.controlArea, "Info")
        self.infoA = gui.widgetLabel(box, "No data on input yet, waiting to get something.")
        self.infoB = gui.widgetLabel(box, "No data on input yet, waiting to get something.")

    @Inputs.a
    def set_data_a(self, a):
        if a is not None:
            self.infoA.setText("Input A is " + str(a.dtype))
            self.a = a
        else:
            self.infoA.setText("No data on input yet, waiting to get something.")

    @Inputs.b
    def set_data_b(self, b):
        if b is not None:
            self.infoB.setText("Input B is " + str(b.dtype))
            self.b = b
        else:
            self.infoB.setText("No data on input yet, waiting to get something.")

    # def subtractor_type(self,block1, block2, type):
    #     b1 = Casting.caster(block1, type)
    #     b2 = Casting.caster(block2, type)
    #     res = numpy.subtract(b1, b2)
    #     return res, type

    def handleNewSignals(self):
        if ((self.Inputs.a is not None) and (self.Inputs.b is not None)):
            self.Outputs.subs.send(numpy.subtract(self.a,self.b))
        else:
            self.Outputs.subs.send(None)
