import numpy
import cv2 as cv
import Orange.data
from .VideoWindow import VideoWindow
from orangewidget.widget import OWBaseWidget, Input, Output
from orangewidget.utils.widgetpreview import WidgetPreview
from orangewidget import gui, settings
from AnyQt import QtCore, QtMultimediaWidgets, QtMultimedia
from AnyQt import QtWidgets, QtGui
class VideoFile(OWBaseWidget):
    name = "VideoFile"
    description = "Search a video file"
    icon = "icons/VideoFile.svg"
    priority = 10
    # Basic (convenience) GUI definition:
    #   a simple 'single column' GUI layout
    want_main_area = False
    #   with a fixed non resizable geometry.
    resizing_enabled = True
    filename = settings.Setting('')
    


    class Outputs:
        url = Output("Video Path", str)
    
    def __init__(self):
        super().__init__()
        box = gui.widgetBox(self.controlArea, "VideoRead")
        self.infoa = gui.widgetLabel(box, 'Click into the button for selecting the video file')
        gui.separator(self.controlArea)
        self.fileOpenButton = QtWidgets.QPushButton('Click to open the file browser',self)
        self.controlArea.layout().addWidget(self.fileOpenButton)
        self.line = gui.lineEdit(widget=self.controlArea, master=self, callback=self.validate, value="filename",
                                 label="Select input video:", orientation="horizontal", callbackOnType=True)
        self.fileOpenButton.clicked.connect(self.buttonClicked)
        gui.separator(self.controlArea)
        box2 = gui.widgetBox(self.controlArea, "VideoPlayer")
        self.videoPath = ''
        self.player = VideoWindow()
        self.player.resize(320, 240)
        self.controlArea.layout().addWidget(self.player)
        self.validate()


        #self.playButton.clicked.connect(self.play)
    def buttonClicked(self):
        print("name")
        fname = QtWidgets.QFileDialog.getOpenFileName(self, 'Open file','c:\\',"Video files (*.mp4 *.avi)")
        self.infoa.setText("The video file: " + fname[0].split('/')[-1] + " has been loaded.")
        self.filename = fname[0]
        self.validate()
    def validate(self):
        if(self.filename != ''):
            self.player.setVideoFile(self.filename)
            self.Outputs.url.send(self.filename)

if __name__ == "__main__":
    WidgetPreview(VideoFile).run()